unit Fuzzy_Reg;

interface

uses
  Graphics,
  SysUtils,
  Classes,
  Forms,
  ExtCtrls;

  Function Fuzzy(pos_otklon:extended):real;
  function Term_Z(A,B:real;pos:extended):real;
  function Term_N(A,B,C:real;pos:extended):real;
  function Term_S(B,C:real;pos:extended):real;
  
implementation

uses Glav;

var
   jach_T: array [1..4] of byte;
   jach_My: array [1..4] of real;
   num_jach:byte;

   (************************************)
           (*   TERM *)

   (*******  Z -term ******************)
 function Term_Z(A,B:real;pos:extended):real;
   begin
   if pos <= (A) then begin Result:=1;  end;

   if (pos > (A)) and (pos <=(B)) then
       begin Result:=(B-pos)/(B-A); end;

   if pos >B then  begin Result:=0; end;

   end;


   (*******  N -term ******************)
 function Term_N(A,B,C:real;pos:extended):real;
   begin
  if pos <= A then  begin Result:=0; end;

  if (pos > A) and (pos <= B) then
   begin Result:=(pos - A)/(B - A);  end;

  if (pos > B) and (pos <= C) then
   begin Result:=(C - pos)/(C - B);    end;

  if pos > C then  begin Result:=0;  end;
   end;

  (*******  S -term ******************)
  function Term_S(B,C:real;pos:extended):real;
   begin
      if pos <= B then begin Result:=0; end;

  if (pos > B) and (pos <=C) then
     begin  Result:=((pos -B)/(C-B));  end;

  if pos >C then begin Result:=1; end;
   end;

  {*****************************************}
    (*    +   *)

    (**********************************)
 procedure Fuzzy_min(naz_term:string;Term,jach:byte;My_otkl,My_Skor:real);
 var Panl:TComponent;
 begin

  Panl:= F_Glav.FindComponent('PanZn' + IntToStr(jach));

   if (My_otkl > 0) and (My_Skor > 0) then
               begin
            num_jach:=num_jach+1; jach_T[num_jach]:=Term;
            (Panl as TPanel).Font.Color:=$0000FF80;
            (Panl as TPanel).Color:=$00A600A6;

      if (My_otkl >My_Skor ) then
         begin jach_My[num_jach]:=My_Skor;
               (Panl as TPanel).Caption:= format('%f',[My_Skor,2]);
         end
       else
         begin jach_My[num_jach]:=My_otkl;
             (Panl as TPanel).Caption:= format('%f',[My_otkl,2]);
         end;
                end
    else
         begin
            (Panl as TPanel).Font.Color:=clWindowText;
            (Panl as TPanel).Caption:=naz_term;
             (Panl as TPanel).Color:=clMoneyGreen;
         end;
 end;

 {*****************************************}
  procedure DeFuzzy_st;
 var Panl:TComponent;
 i:byte;

 begin

  For i:= 1 to 13 do begin

  Panl:= F_Glav.FindComponent('Pan_Vih' + IntToStr(i));

            (Panl as TPanel).Font.Color:=clLime;
            (Panl as TPanel).Caption:='0.00';
            (Panl as TPanel).Color:=clMaroon;
                     end;
 end;

{*****************************************}
 procedure DeFuzzy_Nap(Panel_vih:byte;My:real);
 var Panl:TComponent;
 begin

  Panl:= F_Glav.FindComponent('Pan_Vih' + IntToStr(Panel_vih));
            (Panl as TPanel).Font.Color:=clMaroon;
            (Panl as TPanel).Color:=clYellow;
            (Panl as TPanel).Caption:= format('%f',[My,2]);
  end;

{*****************************************}
Function Fuzzy(pos_otklon:extended):real;
var
    ja_T_rez:  array [1..4] of byte;
    ja_My_rez: array [1..4] of real;

  i,ii:integer;
  my_BOtr_Skor,my_SOtr_Skor,my_MOtr_Skor,my_norm_skor,my_MPol_Skor,my_SPol_Skor,my_BPol_Skor,
  my_BOtr_otkl,my_SOtr_otkl,my_MOtr_otkl,my_norm_otkl,my_MPol_otkl,my_SPol_otkl,my_BPol_otkl,
  P_temp,max,
  P: real;
  E_dif,pos_skor:real;
  (****************************************)


 begin
   E_dif:=pos_otklon-E1;
   E1:=pos_otklon;
   pos_skor:=E_dif; //    

        F_Glav.Ind_Oshibka.Caption:= formatFloat('0.##',pos_otklon);
        F_Glav.Ind_Skor.Caption:= formatFloat('0.##',pos_skor);

   if pos_otklon > otkl_right/10 then pos_otklon:=otkl_right/10;
   if pos_otklon <(otkl_left/10) then pos_otklon:=(otkl_left/10);

   if pos_skor > skor_right/10 then pos_skor:=skor_right/10;
   if pos_skor <(skor_left/10) then pos_skor:=(skor_left/10);

        F_Glav.Chart_Otkl.SeriesList[0].Clear;
        F_Glav.Chart_Otkl.SeriesList[0].AddXY((pos_otklon),0);
        F_Glav.Chart_Otkl.SeriesList[0].AddXY((pos_otklon),1);

        F_Glav.Chart_Skor.SeriesList[0].Clear;
        F_Glav.Chart_Skor.SeriesList[0].AddXY((pos_skor),0);
        F_Glav.Chart_Skor.SeriesList[0].AddXY((pos_skor),1);



 (**    z **)

   (*------------------- O -----------------------*)
   my_BOtr_otkl:=Term_Z(otkl_A1,otkl_B1,pos_otklon);
   F_Glav.ind_BOtr_otkl.Caption:=format('%f',[my_BOtr_otkl,2]);

   (*-------------------- OC ----------------------*)
   my_SOtr_otkl:=Term_N(otkl_A2,otkl_B2,otkl_C2,pos_otklon);
   F_Glav.ind_SOtr_otkl.Caption:=format('%f',[my_SOtr_otkl,2]);

   (*---------------------- O --------------------*)
   my_MOtr_otkl:=Term_N(otkl_A3,otkl_B3,otkl_C3,pos_otklon);
   F_Glav.ind_MOtr_otkl.Caption:=format('%f',[my_MOtr_otkl,2]);

   (*--------------------- H ---------------------*)
   my_norm_otkl:=Term_N(otkl_A4,otkl_B4,otkl_C4,pos_otklon);
   F_Glav.ind_norm_otkl.Caption:=format('%f',[my_norm_otkl,2]);

   (*---------------------  ---------------------*)
   my_MPol_otkl:=Term_N(otkl_A5,otkl_B5,otkl_C5,pos_otklon);
   F_Glav.ind_MPol_otkl.Caption:=format('%f',[my_MPol_otkl,2]);

   (*---------------------  ---------------------*)
   my_SPol_otkl:=Term_N(otkl_A6,otkl_B6,otkl_C6,pos_otklon);
   F_Glav.ind_SPol_otkl.Caption:=format('%f',[my_SPol_otkl,2]);

  (*---------------------  ---------------------*)
   my_BPol_otkl:=Term_S(otkl_A7,otkl_B7,pos_otklon);
   F_Glav.ind_BPol_otkl.Caption:=format('%f',[my_BPol_otkl,2]);




(**     **)



  (*-------------------  -----------------------*)
    my_BOtr_Skor:=Term_Z(Skor_A1,Skor_B1,pos_skor);
    F_Glav.ind_BOtr_Skor.Caption:=format('%f',[my_BOtr_Skor,2]);

  (*--------------------  ----------------------*)

    my_SOtr_Skor:=Term_N(Skor_A2,Skor_B2,Skor_C2,pos_skor);
    F_Glav.ind_SOtr_Skor.Caption:=format('%f',[my_SOtr_Skor,2]);

  (*----------------------  --------------------*)
    my_MOtr_Skor:=Term_N(Skor_A3,Skor_B3,Skor_C3,pos_skor);
    F_Glav.ind_MOtr_Skor.Caption:=format('%f',[my_MOtr_Skor,2]);

  (*---------------------  ---------------------*)
    my_norm_skor:=Term_N(Skor_A4,Skor_B4,Skor_C4,pos_skor);
    F_Glav.ind_norm_Skor.Caption:=format('%f',[my_norm_skor,2]);

  (*---------------------  ---------------------*)
    my_MPol_Skor:=Term_N(Skor_A5,Skor_B5,Skor_C5,pos_skor);
    F_Glav.ind_MPol_Skor.Caption:=format('%f',[my_MPol_Skor,2]);

  (*---------------------  ---------------------*)
    my_SPol_Skor:=Term_N(Skor_A6,Skor_B6,Skor_C6,pos_skor);
    F_Glav.ind_SPol_Skor.Caption:=format('%f',[my_SPol_Skor,2]);
  (*---------------------  ---------------------*)

    my_BPol_Skor:=Term_S(Skor_A7,Skor_B7,pos_skor);
    F_Glav.ind_BPol_Skor.Caption:=format('%f',[my_BPol_Skor,2]);

     (**************************************************)


   num_jach:=0;
             for i:=1 to 4 do
              begin
              jach_T[i]:=0;
              jach_My[i]:=0;
              end;

    (*    +   *)

    (**********************************)

// Fuzzy_min(naz_term:string;Term,jach:byte;My_otkl,My_Skor:real);
  (* 1 *)
 Fuzzy_min('',1,1, my_BOtr_otkl,my_BOtr_Skor);
 Fuzzy_min('',2,2,  my_BOtr_otkl,my_SOtr_Skor);
 Fuzzy_min('',3,3,  my_BOtr_otkl,my_MOtr_Skor);
 Fuzzy_min('',4,4,  my_BOtr_otkl,my_norm_Skor);
 Fuzzy_min('', 5,5,my_BOtr_otkl,my_MPol_Skor);
 Fuzzy_min('',6,6,  my_BOtr_otkl,my_SPol_Skor);
 Fuzzy_min('',7,7,   my_BOtr_otkl,my_BPol_Skor);

  (* 2 *)
 Fuzzy_min('',2,8,  my_SOtr_otkl,my_BOtr_Skor);
 Fuzzy_min('',3,9,  my_SOtr_otkl,my_SOtr_Skor);
 Fuzzy_min('',4,10, my_SOtr_otkl,my_MOtr_Skor);
 Fuzzy_min('',5,11,my_SOtr_otkl,my_norm_Skor);
 Fuzzy_min('',6,12, my_SOtr_otkl,my_MPol_Skor);
 Fuzzy_min('',7,13,  my_SOtr_otkl,my_SPol_Skor);
 Fuzzy_min('',8,14, my_SOtr_otkl,my_BPol_Skor);

 (* 3 *)
 Fuzzy_min('',3,15, my_MOtr_otkl,my_BOtr_Skor);
 Fuzzy_min('',4,16, my_MOtr_otkl,my_SOtr_Skor);
 Fuzzy_min('',5,17,my_MOtr_otkl,my_MOtr_Skor);
 Fuzzy_min('',6,18, my_MOtr_otkl,my_norm_Skor);
 Fuzzy_min('',7,19,  my_MOtr_otkl,my_MPol_Skor);
 Fuzzy_min('',8,20, my_MOtr_otkl,my_SPol_Skor);
 Fuzzy_min('',9,21,my_MOtr_otkl,my_BPol_Skor);

 (* 4 *)
 Fuzzy_min('',4,22, my_norm_otkl,my_BOtr_Skor);
 Fuzzy_min('',5,23,my_norm_otkl,my_SOtr_Skor);
 Fuzzy_min('',6,24, my_norm_otkl,my_MOtr_Skor);
 Fuzzy_min('',7,25,  my_norm_otkl,my_norm_Skor);
 Fuzzy_min('',8,26, my_norm_otkl,my_MPol_Skor);
 Fuzzy_min('',9,27,my_norm_otkl,my_SPol_Skor);
 Fuzzy_min('',10,28,my_norm_otkl,my_BPol_Skor);

 (* 5 *)
 Fuzzy_min('',5,29,my_MPol_otkl,my_BOtr_Skor);
 Fuzzy_min('',6,30, my_MPol_otkl,my_SOtr_Skor);
 Fuzzy_min('',7,31,  my_MPol_otkl,my_MOtr_Skor);
 Fuzzy_min('',8,32, my_MPol_otkl,my_norm_Skor);
 Fuzzy_min('',9,33,my_MPol_otkl,my_MPol_Skor);
 Fuzzy_min('',10,34,my_MPol_otkl,my_SPol_Skor);
 Fuzzy_min('',11,35,my_MPol_otkl,my_BPol_Skor);

 (* 6 *)
 Fuzzy_min('',6,36, my_SPol_otkl,my_BOtr_Skor);
 Fuzzy_min('',7,37,  my_SPol_otkl,my_SOtr_Skor);
 Fuzzy_min('',8,38, my_SPol_otkl,my_MOtr_Skor);
 Fuzzy_min('',9,39,my_SPol_otkl,my_norm_Skor);
 Fuzzy_min('',10,40,my_SPol_otkl,my_MPol_Skor);
 Fuzzy_min('',11,41,my_SPol_otkl,my_SPol_Skor);
 Fuzzy_min('',12,42,my_SPol_otkl,my_BPol_Skor);

 (* 7 *)
 Fuzzy_min('',7,43,   my_BPol_otkl,my_BOtr_Skor);
 Fuzzy_min('',8,44,  my_BPol_otkl,my_SOtr_Skor);
 Fuzzy_min('',9,45, my_BPol_otkl,my_MOtr_Skor);
 Fuzzy_min('',10,46, my_BPol_otkl,my_norm_Skor);
 Fuzzy_min('',11,47, my_BPol_otkl,my_MPol_Skor);
 Fuzzy_min('',12,48, my_BPol_otkl,my_SPol_Skor);
 Fuzzy_min('',13,49,my_BPol_otkl,my_BPol_Skor);

    (**********************************)
             for i:=1 to 4 do
              begin
                 ja_T_rez[i]:=0;
                 ja_My_rez[i]:=0;
               end;


   (*********************** Fazzyfik **********************)

  
  (* 1 ------------------------------------------*)
(**)  if jach_T[1]=jach_T[2] then    (*  1 = 2 *)

  (* 2 ------------------------------------------*)
  (***)         if jach_T[1]=jach_T[3] then       (*  1 = 2 = 3 *)

  (* 3 ------------------------------------------*)
 (****)             if jach_T[1]=jach_T[4] then    (*  1 = 2 = 3 = 4 * 1*)
                        begin
                         max := jach_My[1];
                         for ii:=2 to 4 do begin
                         if max < jach_My[ii] then max:= jach_My[ii];
                                          end;
                                           ja_My_rez[1]:=max;
                        end
          (****)    else   (*  1 = 2 = 3 <> 4 *  2*)
                       begin
               max := jach_My[1];
                         for ii:=2 to 3 do begin
                         if max < jach_My[ii] then max:= jach_My[ii];
                                          end;
                             ja_My_rez[1]:=max;         ja_T_rez[1]:=jach_T[1];
                             ja_My_rez[2]:=jach_My[4]; ja_T_rez[2]:=jach_T[4];
                        end
     (* ------------------------------------------*)
    (***)   else     (* 4 ? 1 = 2 <> 3 ? 4 *)
      begin

             if jach_T[3]= jach_T[4] then
           begin     (* 4 <> 1 = 2 <> 3 = 4 * 3 *)
                  (*-----------------------------------*)
                                     if jach_My[1]> jach_My[2] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[2];
                                                  ja_T_rez[1]:=jach_T[2];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                                    if jach_My[3]> jach_My[4] then
                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[4];
                                                  ja_T_rez[2]:=jach_T[4];
                                           end;
                   (***-------------------------------***)
            end
                else  (* 4 ? 1 = 2 <> 3 <> 4 *)
            begin
                                  if jach_T[1]= jach_T[4] then   (* 4=1=2<>3<>4 * 4 *)
                    begin
                   (***-------------------------------***)
                                     max:=jach_My[1];
                                           if jach_My[2]> max then     max:=jach_My[2];
                                           if jach_My[4]> max then     max:=jach_My[4];

                                         //  begin
                                                  ja_My_rez[1]:=max;
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                         //  end;
                     end
                                    else
                                              (* 4<>1=2<>3<>4 * 5 *)

                    begin
                                           (*-----------------------------------*)
                                     if jach_My[1]> jach_My[2] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[2];
                                                  ja_T_rez[1]:=jach_T[2];
                                            end;
                   (*-----------------------------------*)

                                                  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                                  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];
                    end;
             end;

         end
 (* 3 ------------------------------------------*)

else


  (******************** 1 *************************)

  if jach_T[2]=jach_T[3] then   (* 4 ? 1 <> 2 = 3 ? 4 *)
  begin
  (*************-------------------------------*)
      (*****)  if jach_T[2]=jach_T[4] then       (* 4 <> 1 <> 2 = 3 = 4 *  6 *)
  (* 3 ------------------------------------------*)
          begin
                           max:=jach_My[2];
                           if jach_My[3]> max then     max:=jach_My[2];
                           if jach_My[4]> max then     max:=jach_My[4];

                                           begin
                                                  ja_My_rez[1]:=jach_My[1];
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[2]:=max;
                                                  ja_T_rez[2]:=jach_T[2];

                                           end;
          end
      (*****)        else   (* 4 ? 1 = 2 = 3 <> 4 *)
          begin
       (* ------------------------------------------*)
    (***-***)         if jach_T[1]=jach_T[4] then    (* 4= 1 <> 2 = 3 <> 4 * 7 *)
                begin
                       (*-----------------------------------*)
                    if jach_My[1]> jach_My[4] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[4];
                                                  ja_T_rez[1]:=jach_T[4];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                    if jach_My[2]> jach_My[3] then
                                           begin  ja_My_rez[2]:=jach_My[2];
                                                  ja_T_rez[2]:=jach_T[2];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end;
                   (***-------------------------------***)
                end
    (*  ------------------------------------------*)
     (***-***)        else    (* 4<> 1 <> 2 = 3 <> 4 *  8 *)

                begin
                       (*-----------------------------------*)
                    if jach_My[2]> jach_My[3] then
                                          begin  ja_My_rez[2]:=jach_My[2];
                                                 ja_T_rez[2]:=jach_T[2];
                                           end
                                     else

                                           begin  ja_My_rez[2]:=jach_My[3];
                                                  ja_T_rez[2]:=jach_T[3];
                                           end;
                   (*-----------------------------------*)
                   (***-------------------------------***)
                                                  ja_My_rez[1]:=jach_My[1];
                                                  ja_T_rez[1]:=jach_T[1];
                                                  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];

                   (***-------------------------------***)
                 end;
             end;
   end

 (******************** 2 *************************)


   else         (* 4 ? 1 <> 2 <> 3 ? 4 *)


 begin
(*----*) if jach_T[3]= jach_T[4] then    (* 4 ? 1 <> 2 <> 3 = 4 *)
       begin
   (**-*-**) if jach_T[4]= jach_T[1] then     (* 4 = 1 <> 2 <> 3 = 4 *  9 *)
                  (*-----------------------------------*)
                   begin
                                           max:=jach_My[1];
                           if jach_My[3]> max then     max:=jach_My[3];
                           if jach_My[4]> max then     max:=jach_My[4];

                                           ja_My_rez[1]:=max;
                                           ja_T_rez[1]:=jach_T[1];
                                           ja_My_rez[2]:=jach_My[2];
                                           ja_T_rez[2]:=jach_T[2];
                   end
  (**-*-**)  else            (* 4 <> 1 <> 2 <> 3 = 4 * 10 *)
                   begin
                           if jach_My[3]> jach_My[4] then
                                           begin  ja_My_rez[3]:=jach_My[3];
                                                  ja_T_rez[3]:=jach_T[3];
                                           end
                                     else

                                           begin  ja_My_rez[3]:=jach_My[4];
                                                  ja_T_rez[3]:=jach_T[4];
                                           end;
                   (***-------------------------------***)
                                           ja_My_rez[1]:=jach_My[1];
                                           ja_T_rez[1]:=jach_T[1];
                                           ja_My_rez[2]:=jach_My[2];
                                           ja_T_rez[2]:=jach_T[2];

                     end;
        end

(*----*) else
   // .........................................
        begin
       (* ------------------------------------------*)
             if jach_T[1]=jach_T[4] then    (* 4= 1 <> 2 <> 3 <> 4 * 11 *)
                        begin
                       (*-----------------------------------*)
                    if jach_My[1]> jach_My[4] then
                                          begin  ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                           end
                                     else

                                           begin  ja_My_rez[1]:=jach_My[4];
                                                  ja_T_rez[1]:=jach_T[4];
                                           end;
                   (*-----------------------------------*)

                                                  ja_My_rez[2]:=jach_My[2];
                                                  ja_T_rez[2]:=jach_T[2];
                                                  ja_My_rez[3]:=jach_My[3];
                                                  ja_T_rez[3]:=jach_T[3];
                         end


    (*  ------------------------------------------*)
               else    (* 4<> 1 <> 2 <> 3 <> 4 *  12 *)

                      begin
                                                 ja_My_rez[1]:=jach_My[1];
                                                 ja_T_rez[1]:=jach_T[1];
                                                 ja_My_rez[2]:=jach_My[2];
                                                 ja_T_rez[2]:=jach_T[2];
                                                 ja_My_rez[3]:=jach_My[3];
                                                 ja_T_rez[3]:=jach_T[3];
                                                 ja_My_rez[4]:=jach_My[4];
                                                 ja_T_rez[4]:=jach_T[4];

                        end;
          end

 end;
(*------------------------------------------*)

P_temp:=0;

 DeFuzzy_st;
       
(*------------------------------------------*)



{*****************************************}

for  i := 1 to 4 do
begin
  case (ja_T_rez[ i]) of
   1:  Begin P_temp:=P_temp + vih_1* ja_My_rez[i];
             DeFuzzy_Nap(1,ja_My_rez[i]); end;// 
   2:  Begin P_temp:=P_temp + vih_2* ja_My_rez[i];
             DeFuzzy_Nap(2,ja_My_rez[i]);end;// 
   3:  Begin P_temp:=P_temp + vih_3* ja_My_rez[i];
             DeFuzzy_Nap(3,ja_My_rez[i]);end;// 
   4:  Begin P_temp:=P_temp + vih_4* ja_My_rez[i];
             DeFuzzy_Nap(4,ja_My_rez[i]);end;// 
   5:  Begin P_temp:=P_temp + vih_5* ja_My_rez[i];
             DeFuzzy_Nap(5,ja_My_rez[i]);end;// 
   6:  Begin P_temp:=P_temp + vih_6* ja_My_rez[i];
             DeFuzzy_Nap(6,ja_My_rez[i]);end;// 
   7:  Begin P_temp:=P_temp + vih_7* ja_My_rez[i];
             DeFuzzy_Nap(7,ja_My_rez[i]);end;// 
   8:  Begin P_temp:=P_temp + vih_8* ja_My_rez[i];
             DeFuzzy_Nap(8,ja_My_rez[i]);end;// 
   9:  Begin P_temp:=P_temp + vih_9* ja_My_rez[i];
             DeFuzzy_Nap(9,ja_My_rez[i]);end;// 
   10: Begin P_temp:=P_temp + vih_10* ja_My_rez[i];
             DeFuzzy_Nap(10,ja_My_rez[i]);end;// 
   11: Begin P_temp:=P_temp + vih_11* ja_My_rez[i];
             DeFuzzy_Nap(11,ja_My_rez[i]);end;// 
   12: Begin P_temp:=P_temp + vih_12* ja_My_rez[i];
             DeFuzzy_Nap(12,ja_My_rez[i]);end;// 
   13: Begin P_temp:=P_temp + vih_13* ja_My_rez[i];
             DeFuzzy_Nap(13,ja_My_rez[i]);end;// 
   end;
 end;

   P_temp:= P_temp /(ja_My_rez[1]+ja_My_rez[2]+ja_My_rez[3]+ja_My_rez[4]);

    Result:= P_temp;
   (************* END DeFazzyfi **********************)
   
 
end;
end.



end.
